#!/usr/bin/perl
#
######################################################################
###
###
###  CGI簡易掲示版 T-Note-cap Ver.4.05 + captcha
###     [1/1] 本体 (tnote_cap.cgi)
###                                 (c) 1996-2005 Takahiro Nishida
###                                 http://www.mytools.net/
###  Modiry By Lenin Oyama
###
###
######################################################################
#
use lib qw(./lib); # Edit it
use GD::SecurityImage::AC;

$basedir = ".";
$rejectfile = 'reject.txt';

### キャプチャ設定 ###################################################
$capdata = "$basedir/lockdir";
$caphttp = "$basedir/authx";
$capurl = "authx";
$caplen = 4;
$captcha = Authen::Captcha->new(
    data_folder => $capdata,
    output_folder => $caphttp,
    expire => 5600
);
$captcha->gdsi(
      new => {
          width    => 130,
          height   => 46,
          lines    => 4,
          font => '/usr/share/fonts/sazanami/gothic/sazanami-gothic.ttf', # Edit it
          scramble => 0,
          ptsize => 26,
      },
      create   => [ttf => 'default', '#500040', '#500040'],
      particle => [15, 25],
);
$captcha->keep_failures( 1 );
### 変数設定部 （詳細は上記ページをご覧下さい） ######################

# データファイルの入っているディレクトリ
# CGIプログラムの拡張子
$ext = "cgi";
# フォームの送信方法
$method = "post";
# 管理パスワード
$password = 'changeme';
# 管理者メールアドレス
$admin_email = 'lenin@example.me';
# 文章の最大長（全角での文字数）
$max_words = 3000;

### 変数設定部 （ここまで）###########################################

# 標準時とのズレ（時間）
$time_fix = 0;
# 標準のBOOK名
$default_book = "book1";
# クッキーの有効期限（日）
$cookie_lifetime = 30;
# スクリプトの名前
$script_name = "tnote_cap";
# クッキーのPATHの設定／非設定
$enable_cookiepath = 1;
# 更新日を見るためのキーワード
$update_keyword = "aisiteru4";
# スパム扱いするキーワード
@spamwords = ( '&LT;url' , '&LT;URL' , 'cialis' , 'viagra' , ':-(' , ';-)' );
# スパムエラー時のメッセージ（0-14:適当なメッセージ、15:スパム専用メッセージ、詳しくはerror関数を参照）
$SPAM_ERROR_ID = 15;


# jcode.plの位置
#require './jcode.pl';

##### 発言表示のテンプレート
# "#xxx#" のところに文字が埋め込まれる（xxxの種類は以下の通り）
#	ID ... 発言ID
#	HEAD ... 発言タイトル
#	NAME ... 名前
#	MAIL ... メールアドレス
#	URL ... ページのＵＲＬ
#	CONT ... 発言内容
#	REPLY ... 返信フォーム、返信文

sub article_template{
	"
<TABLE width=\"84\%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
<TR>
<TD width=\"20\"></TD>
<TD height=\"5\"></TD></TR>
<TR>
<TD></TD>
<TD>
<P>
<A name=\"#ID#\">
<FONT size=\"3\">
<FONT SIZE=\"2\" COLOR=\"$cnumb\"><B>No.#ID#</B> (#DATE#)</FONT>&nbsp;&nbsp;
<BR><B><FONT size=\"4\" color=\"$chead\">「#HEAD#」</FONT></B><BR>
<FONT SIZE=\"3\" COLOR=\"$cname\">
<B>　<A HREF=\"mailto:#MAIL#\">#NAME#</A></B></FONT>#HOST#
<FONT size=\"2\"><B>　ＵＲＬ:</B><A HREF=\"#URL#\">#URL#</A><P></FONT>
#CONT#<P>
#REPLY#
</FONT>
</TD></TR>
<TR>
<TD></TD>
<TD height=\"5\"></TD></TR>
</TABLE>
<HR NOSHADE SIZE=\"1\">
	";
}

##### 標準の配色、背景画像
$defcol = "#333333,#FFFFFF,#0000BB,#000099,#FF0000,#CC00FF,#FF5555,#6699FF,#FF3333,#003300,";

$lockfile = "$basedir/lockdir/tn.lock";
$pwdfile = "$basedir/tnpwd.$ext";
$verno = '4.05';

&main;

sub main{
	&lock;
	&init_variables;
	&check_input;
	&open_datafiles;
	&exec_admin;
	&get_configs;
	&add_newdata;
	&add_newreply;
	&cut_log;
	&update_datafiles;
	&deal_cookie;
	&select_datas;
	&cut_data;
	&show_html;
	&unlock;
}



########## 変数の初期化
sub init_variables{
	local($addr);
	### ホスト名
	$addr = $ENV{'REMOTE_ADDR'};
	$host = $ENV{'REMOTE_HOST'};
	($addr eq $host) && ($host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2));
	$host = $host || $addr || "";
	### 時刻（秒、時間）
	$date_now = &get_time(time);
        if(open(RJ,$rejectfile)){
          while($line = <RJ>){
                $line =~ s/[\r\n]//g;
                if($host =~ /^$line$/){
                        &error(17);
                }
                if($line =~ /.*\.$/){
                        if($host =~ /^$line.*/){
                                &error(17);
                        }
                }
          }
          close(RJ);
	}
}



########## 入力の受け取り、チェック
sub check_input{
	local($buffer, $vn, $pair, @pairs);
	
	if ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}
	else {
		$buffer = $ENV{'QUERY_STRING'};
	}
	
	### 各ノートの更新日表示
	($update_keyword) && ($buffer eq $update_keyword) && (&show_update);
	
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
		($vn, $value) = split(/=/, $pair);
		$F{$vn} .= $value;
	}
	
	$book = $F{'book'} || $default_book || &error(3);
	$name = &decode($F{'name'});
	$mail = &decode($F{'mail'});
	$url  = &decode($F{'url'});
	$head = &decode($F{'head'});
	$cont = &decode($F{'cont'});
	$pid  = $F{'pid'};
	$find = &decode($F{'find'});
	$page = $F{'page'};
	$cook = $F{'cook'};
	$rcont= $F{'rcont'};
	$pwd  = $F{'pwd'};
	$ppr  = $F{'ppr'};
	$type = $F{'type'} || 'and';
	
	($book =~ /^\w+$/) || &error(4);
	(!$mail) || ($mail =~ /^[\w\-\+\.]+\@[\w\-\+\.]+$/) || &error(5);
	(!$url) || ($url =~ /^http:\/\/+./) || &error(6);
	(!$pid) || ($pid =~ /^\d+$/) || &error(7);
	
	### スパムキーワードチェック
	&check_spamword($head) && &error($SPAM_ERROR_ID);
	&check_spamword($cont) && &error($SPAM_ERROR_ID);

        # キャプチャ画像チェック
        $checkcode = &decode($F{'capcode'});
        $checkmd5sum = &decode($F{'md5sum'});
        if($checkmd5sum ne ""){
                my $results = $captcha->check_code($checkcode,$checkmd5sum);
                if( $results != 1 ){
                        error(16);
                }
        }else{
                if( $cont ne "" ){
                        error(16);
                }
        }

}



########## 更新日の表示
sub show_update{
	local($htmlbuf, $file, $book_name, $datafile, $book_update, $book_title);
	opendir(DIR, $basedir) || &error(14, "ディレクトリが開けません");
	
	$htmlbuf  = "Content-type: text/html\n\n";
	$htmlbuf .= "<H3>更新日一覧</H3>\n";
	$htmlbuf .= "<TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\">\n";
	$htmlbuf .= "<TR><TH>タイトル</TH><TH>BOOK名</TH><TH>更新日付</TH></TR>\n";
	
	while($file = readdir(DIR)){
		($file =~ /^(\w+)\.txt$/) || next;
		$book_name = $1;
		$datafile = "$basedir/$file";
		
		&openfile($datafile, *datas);
		($datas[3] =~ /^\d+\n$/) || next;
		
		@t = stat($datafile);
		$book_update = &get_time($t[9]);
		
		$book_title = (split("\t", $datas[0]))[1];
		
		$htmlbuf .= "<TR><TD>$book_title</TD>\n";
		$htmlbuf .= "<TD><A HREF=\"./$script_name.$ext?book=$book_name\">$book_name</A></TD>\n";
		$htmlbuf .= "<TD>$book_update</TD></TR>\n";
	}
	$htmlbuf .= "</TABLE>\n";
	closedir(DIR);
	
	print $htmlbuf;
	&unlock;
	exit;
}



########## ファイルのオープン
sub open_datafiles{
	$datafile = "$basedir/$book.txt";
	&openfile($datafile, *datas);
	
	### 初めての場合
	if($datas[0] !~ /\t/){
		&init_config;
	}
	### Ver.3 -> Ver.4
	elsif($datas[3] !~ /^\d+\n$/){
		&ver3to4;
	}
}



########## アップグレード
sub ver3to4{
	local($newline, $tid, $ttime, $tname, $tmail, $turl, $tcont, $thost, $thead);
	
	$tid = 1;
	for (4..$#datas){
		if($datas[$_] =~ /^\n$/){
			$newline = "$tid\tD\t\n";
		}
		else{
			($ttime, $tname, $tmail, $turl, $tcont, $thost, $thead) = split("\t", $datas[$_]);
			$newline = "$tid\t\t$ttime\t$tname\t$thost\t$tmail\t$turl\t$thead\t$tcont\t\t\n";
		}
		$datas[$_] = $newline;
		$tid++;
	}
	# コンフィグ行初期化（行数は一緒なので）
	&init_config($tid-1); 
	
	$upf_data = 1;
}



########## 管理
sub exec_admin{
	($pwd) || return;
	local($pwdmatch, $i, $delpos);
	local($id, $pid, $date, $name, $host, $mail, $url, $head, $cont, $repline);
	
	# 入力チェック
	$delid = $F{'delid'};
	$delre = $F{'delre'};
	(!$delid) || ($delid =~ /^\d+/) || &error(9);
	(!$delre) || ($delre =~ /^\d+/) || &error(9);
	
	# マッチング用にハッシュを作る
	&openfile($pwdfile, *pwds);
	foreach(@pwds){
		($cbook, $cid, $cpwd) = split("\t");
		$UP{"$cbook\t$cid"} = $cpwd;
	}
	
	# システム管理者又はbook管理者なら無条件
	if(($pwd eq $password) || ($UP{"$book\tADM"} eq $pwd)){
		$pwdmatch = 1;
	}
	
	### この時点で更新フラグを立てとく（安全策）
	$upf_data = 1;
	
	### 削除
	if($F{'del'}){
		# 親がないことはあり得ない
		($delid) || &error(9);
		# 対応するハッシュキー
		$delkey = ($delre) ? "$book\t$delid-$delre" : "$book\t$delid";
		# 権限チェック
		($pwdmatch) || ($UP{$delkey} eq $pwd) || &error(8);
		
		### 消す
		for(4..$#datas){
			if($datas[$_] =~ /^$delid\t\d*\t/){
				# Replyの削除
				if($delre){
					($id, $pid, $date, $name, $host, $mail, $url, $head, $cont, $repline) = split("\t", $datas[$_]);
					@replys = split("<R>", $repline);
					$repline = "";
					foreach $brep(@replys){
						($brep =~ /<>$delre$/) || ($repline .= $brep . "<R>");
					}
					$datas[$_] = "$id\t$pid\t$date\t$name\t$host\t$mail\t$url\t$head\t$cont\t$repline\t\n";
				}
				# 発言自体の削除
				else{
					$datas[$_] = "$delid\tD\t\n";
				}
			}
		}
		
		# 対応する削除キーを削除
		delete($UP{$delkey});
		# 更新用に配列に納め直す
		undef @pwds;
		while(($key, $value) = each %UP){
			push(@pwds, "$key\t$value\t\n");
		}
		# 更新フラグ
		$upf_pwd = 1;
	}
	
	### 管理
	if($F{'admin'}){
		$admmode = 1;
		($pwdmatch) || &error(8);
		&update_config;
	}
}



########## 設定の変更
sub update_config{
	($F{'fix'}) || return;
	local($atitle, $ahead, $acom, $aback, $asdef, $acol, $abpwd);
	local(@sws, $i, $delpos);
	
	$atitle = &decode($F{'atitle'});
	$ahead  = &decode($F{'ahead'}, 1);
	$acom   = &decode($F{'acom'}, 1);
	$aback  = &decode($F{'aback'});
	$asdef  = $F{'asdef'};
	$acol   = &decode($F{'acol'});
	$abgimg = &decode($F{'abgimg'});
	$abpwd   = &decode($F{'abpwd'});
	
	($asdef =~ /^\d+$/) || &error(11, '発言単位');
	($F{'alg'} =~ /\d+$/) || &error(11, '最大ログ件数');
	($F{'colreset'}) && ($acol = $defcol);
	
	$datas[0] = "$ahead\t$atitle\t$acom\t$aback\t\n";
	$datas[1] = "$acol$abgimg,\n";
	$datas[2] = "$asdef,";
	
	@sws = ('afm', 'apv', 'app', 'asc', 'ahd', 'ahs', 'arp', 'asd', 'aan', 'alg');
	foreach(@sws){
		$datas[2] .= $F{$_} . ",";
	}
	$datas[2] .= "\n";
	
	$upf_data = 1;
}



########## コンフィグ行の初期化
sub init_config{
	local($bid) = @_;
	($bid) || ($bid = "0");
	
	$datas[0] = "<H3>見だしはここ</H3>\tタイトル\t説明文をここに書いて下さい\thttp://www.your/homepage/\t\n";
	$datas[1] = "$defcol,,\n";
	$datas[2] = "20,1,1,1,1,1,1,1,1,1,0,\n";
	$datas[3] = "$bid\n";
	$upf_data = 1;
}



########## 設定を取得
sub get_configs{
	@configs = @datas[0..3];
	### タイトル文字列など
	($headline, $title, $comment, $backurl) = split("\t", $configs[0]);
	### 配色
	($ctext, $cbody, $clink, $cvlnk, $calnk, $cname, $cnumb, $chead, $crnam, $crtxt, $bgimg) = split(",", $configs[1]);
	### 各種スイッチ
	($show_scale, $sw_form, $sw_preview, $sw_ppr, $sw_search, $sw_head, $sw_host, $sw_reply, $sw_showdel, $sw_anobar, $sw_log) = split(",", $configs[2]);
}



########## 新規発言の追加
sub add_newdata{
	($name && $cont && !$F{'search'}) || return;
	local($newid);
	
	# 削除パスワードが必須なのにない場合はエラー
	($sw_ppr == 2) && (!$ppr) && &error(14);
	
	# 発言番号
	$newid = ++$datas[3];
	$datas[3] .= "\n";
	# 新規行
	$newline = "$newid\t$pid\t$date_now\t$name\t$host\t$mail\t$url\t$head\t$cont\t\t\n";
	# プレビューだったらここで終了
	($F{'chk'}) && return;
	# 新規行の格納
	push(@datas, $newline);
	$upf_data = 1;
	# 削除パスワードが入力されていたら追加
	if($ppr){
		$newpwds[0] = "$book\t$newid\t$ppr\t\n";
		$adf_pwd = 1;
	}
}



########## 新規コメントの追加
sub add_newreply{
	($F{'reply'}) || return;
	local($tmp, $pwdmatch);
	
	$repid   = $F{'repid'};
	$repname = &decode($F{'repname'});
	$repcont = &decode($F{'repcont'});
	
	&check_spamword($repname.$repcont) && &error($SPAM_ERROR_ID);
	
	if($sw_reply == 2){
		($pwd) || &error(8);
		# マッチング用にハッシュを作る
		&openfile($pwdfile, *pwds);
		foreach(@pwds){
			($cbook, $cid, $cpwd) = split("\t");
			$UP{"$cbook\t$cid"} = $cpwd;
		}
		# システム管理者かbook管理者じゃなきゃダメ
		($password eq $pwd) || ($UP{"$book\tADM"} eq $pwd) || &error(8);
	}
	else{
		# 削除パスワードが必須なのに無い場合はエラー
		($sw_ppr == 2) && (!$ppr) && &error(14);
	}
	
	($repid > 0) || &error(7);
	($repname && $repcont) || &error(12);
	
	for(4..$#datas){
		if($datas[$_] =~ /^$repid\t(.+)\t/){
			($1 eq "D") && &error(7);
			$rno = ($datas[$_] =~ /<>(\d+)<R>\t\n/) ? $1 + 1 : 1;
			$repline = "$date_now<>$repname<>$repcont<>$rno<R>";
			$datas[$_] =~ s/\t\n/$repline\t\n/;
			$upf_data = 1;
		}
	}
	
	($upf_data) || &error(7);
	
	# 削除パスワードが入力されていたら追加
	if($ppr){
		$newpwds[0] = "$book\t$repid-$rno\t$ppr\t\n";
		$adf_pwd = 1;
	}
}



########## ログの削除
sub cut_log{
	# ログ数が指定されていなかったら終了
	($sw_log > 0) || return;
	# ログ数が規定を超えてなければ終了
	(@datas > $sw_log + 4) || return;
	# カット
	splice(@datas, 4, @datas - 4 - $sw_log);
	# 更新フラグ
	$upf_data = 1;
}



########## データファイルの更新
sub update_datafiles{
	($upf_data) && &updatefile($datafile, *datas);
	($upf_pwd) && &updatefile($pwdfile, *pwds);
	($adf_pwd) && &updatefile($pwdfile, *newpwds, 1);
}



########## データの抽出
sub select_datas{
	# コンフィグ行を削り落とす
	splice(@datas, 0, 4);
	# 全件数
	$hitno = $allno = @datas;
	# 新しい順にするためひっくり返す
	@datas = reverse(@datas);
	# 検索でない場合は終了
	($F{'search'}) || return;
	# 検索文字列が指定されていなかったらヒット無しにして終了
	if($find eq ''){
		@datas = ();
		$hitno = 0;
		return;
	}
	
	local($bid, $bpid, $bdate, $bname, $bhost, $bmail, $burl, $bhead, $bcont, $breps);
	local(@hits, $efind, $match, $pattern);
	
	# 検索文字の処理
	$efind = $find;
	$efind =~ s/　/ /g;
	$efind =~ s/(\W)/\\$1/g;
	# 空白で分割
	@efinds = split(/\\\s+/, $efind);
	
	### 検索
	foreach(@datas){
		($bid, $bpid, $bdate, $bname, $bhost, $bmail, $burl, $bhead, $bcont, $breps) = split("\t");
		$str = "($bid)\t$bid\t$bname\t$bmail\t$burl\t$bhead\t$bcont\t$breps";
		$match = 0;
		
		# マッチング
		foreach $pattern(@efinds){
			if($str =~ /$pattern/){
				$match++;
			}
		}
		### and検索の場合、マッチ数が文字数に一致しなければダメ
		($type eq 'and') && ($match < @efinds) && ($match = 0);
		($match != 0) && push(@hits, "$bid\t$bpid\t$bdate\t$bname\t$bhost\t$bmail\t$burl\t$bhead\t$bcont\t$breps\t\n");
	}
	
	@datas = @hits;
	$hitno = @datas;
	
	($hitno) || ($html_nomatch = "<H3><FONT COLOR=\"$cnumb\">ヒットしませんでした。<BR>条件を変えて再度検索してください。</FONT></H3><HR NOSHADE SIZE=\"1\">");
}



########## データを表示単位で切り抜く
sub cut_data{
	local($t, $f);
	
	### 範囲指定が変だったら一ページ目を表示
	$page = int($page);
	$allpage = int(($hitno-1) / $show_scale) + 1;
	($page > 0) && ($page <= $allpage) || ($page = 1);
	
	### 表示範囲の特定
	$t = $page * $show_scale;
	$f = $t - $show_scale + 1;
	($t < $hitno) ? ($next = $page + 1) : ($t = $hitno);
	($f > 1) && ($prev = $page - 1);
	
	### 前後を切り取る
	unshift(@datas, "dmy");
	@datas = splice(@datas, $f, $show_scale);
}



########## ページリンク
sub html_pagelink{
	local($htmlbuf, $no_f, $no_t, $linkcgi);
	
	$htmlbuf = "<FONT SIZE=\"2\"><B>";
	
	### 通常モード
	if(!$F{'search'}){
		$linkcgi = "$script_name.$ext?book=$book";
		($no_f) = $datas[0]	   =~ m|^(\d+)\t|;
		($no_t) = $datas[$#datas] =~ m|^(\d+)\t|;
		
		# 全保存件数
		$htmlbuf .= "<FONT COLOR=\"$cnumb\">全$allno件</FONT>&nbsp;";
		
		# 表示範囲
		$htmlbuf .= "<FONT COLOR=\"$cnumb\">【No.$no_f-$no_t】</FONT>&nbsp;／&nbsp;";
		
		# 最新xx件
		$htmlbuf .= "<A HREF=\"$linkcgi\">最新$show_scale件</A>&nbsp;";
	}
	### 検索モード
	else{
		$linkcgi = "$script_name.$ext?book=$book&amp;search=true&amp;find=$F{'find'}&amp;type=$type";
		$htmlbuf .= "<FONT COLOR=\"$cnumb\">文字列</FONT>：";
		$htmlbuf .= $find || "----";
		$htmlbuf .= "&nbsp;<I>($type)</I>&nbsp;";
		$htmlbuf .= "／&nbsp;<FONT COLOR=\"$cnumb\">ヒット数</FONT>：";
		$htmlbuf .= $hitno || "--";
		$htmlbuf .= "件&nbsp;";
	}
	
	### 前のxx件
	$htmlbuf .= ($prev) ?
		"／&nbsp;<A HREF=\"$linkcgi&amp;page=$prev\">↑$show_scale件</A>&nbsp;" :
		"／&nbsp;先頭です&nbsp;";
	
	### 後のxx件
	$htmlbuf .= ($next) ?
		"／&nbsp;<A HREF=\"$linkcgi&amp;page=$next\">$show_scale件↓</A>" :
		"／&nbsp;末尾です";
	
	### 検索窓
	if($sw_search){
		$htmlbuf .= ($F{'search'}) ?  "／&nbsp;<A HREF=\"$script_name.$ext?book=$book&amp;\">通常モード</A>&nbsp;" : "／&nbsp;<A HREF=\"$linkcgi&amp;search=true\">検索モード</A>&nbsp;";
	}
	
	### 新規書き込み
	if(!$sw_form && !$F{'search'}){
		$htmlbuf .= "／&nbsp;<A HREF=\"#form\">発言する</A>&nbsp;";
	}
	
	$htmlbuf .= "</B></FONT><HR NOSHADE SIZE=\"1\">";
	
	$htmlbuf;
}



########## 画面表示
sub show_html{
	local($htmlbuf);
	
	$pagelink = &html_pagelink;
	
	$htmlbuf  = &html_header;
	$htmlbuf .= &html_form_admin if ($admmode); 
	$htmlbuf .= &html_form_new if (!$F{'search'} && $sw_form && !$admmode); # 発言欄が上の場合
	$htmlbuf .= &html_preview if ($F{'chk'} && $name && $cont);
	$htmlbuf .= &html_search if ($F{'search'});
	$htmlbuf .= $pagelink . $html_nomatch;
	$htmlbuf .= &html_articles;
	$htmlbuf .= $pagelink;
	$htmlbuf .= &html_form_new if (!$F{'search'} && !$sw_form && !$admmode); # 発言欄が下の場合
	$htmlbuf .= &html_form_delete;
	$htmlbuf .= &html_footer;
	
	print $cookieline;
	print "Content-type: text/html\n";
	print "\n";
	print $htmlbuf;
}



########## ヘッダ
sub html_header{
	if($sw_anobar){
		$cssbuf = "
		<STYLE TYPE=\"text/css\">
		<!--
		A{TEXT-DECORATION:none}
		-->
		</STYLE>
		";
	}
	
	"
<HTML>
<HEAD>
<META http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">
<META http-equiv=\"Content-Style-Type\" content=\"text/css\">
<TITLE>$title</TITLE>
$cssbuf
</HEAD>
<BODY BGCOLOR=\"$cbody\" BACKGROUND=\"$bgimg\" LINK=\"$clink\" VLINK=\"$cvlnk\" ALINK=\"$calnk\">
<FONT COLOR=\"$ctext\">
<FONT SIZE=\"2\">[<A HREF=\"$backurl\">戻る</A>]</FONT><P>
$headline<P>
$comment
<HR NOSHADE SIZE=\"1\">
	";
}



########## フッタ
sub html_footer{
	"
<DIV ALIGN=\"right\">
<TABLE BORDER=\"2\" CELLPADDING=\"0\" CELLSPACING=\"0\">
<TR><TD BGCOLOR=\"\#FFFF99\">
<A HREF=\"https://www.hasiru.net/\" TARGET=\"_top\">
<FONT SIZE=\"2\" COLOR=\"#000099\">
<B>Powered by T-Note-cap Ver.$verno</B>
</FONT></A></FONT>
</TD></TR></TABLE></DIV>
</FONT></BODY></HTML>
	";
}



########## 入力フォーム
sub html_form_new{
	local($html_pphrase, $html_preview, $html_head);
	local($contbuf, $headbuf);
	$md5sum = $captcha->generate_code($caplen);
	
	### プレビューの場合元の情報を載せる
	if($F{'chk'}){
		### タグを改行に逆変換
		$contbuf = $cont;
		$contbuf =~ s/<BR>/\n/g;
		$contbuf =~ s/<P>/\n\n/g;
		$headbuf = $head;
	}
	
	### スイッチ処理
	# 削除キー入力欄
	if($sw_ppr){
		$pprcase = ($sw_ppr == 2) ? "<FONT COLOR=\"#FF0000\"><B>（必須）</B></FONT>" : "書かない場合発言の削除ができません";
		
		$html_pphrase = "
		<FONT SIZE=\"3\">削除キー：
		<INPUT TYPE=\"password\" NAME=\"ppr\" SIZE=\"8\" VALUE=\"$ppr\"></FONT>&nbsp;
		<FONT SIZE=\"2\">※ <A HREF=\"#delform\">発言削除</A>用のパスワード。$pprcase</FONT>
		";
	}
	
	# プレビューボタン
	$html_submitlabel = "発言";
	if($sw_preview == 1){
		$html_preview = "<INPUT TYPE=\"submit\" NAME=\"chk\" VALUE=\"プレビュー\">";
	}
	# 常にプレビュー
	elsif($sw_preview == 2){
		$html_submitlabel = "プレビュー";
		$html_prehidden = "<INPUT TYPE=\"hidden\" NAME=\"chk\" VALUE=\"1\">\n";
	}
	
	# 発言タイトル入力欄
	if($sw_head){
		$html_head = "
		<TR><TH WIDTH=\"50\" ALIGN=\"right\" NOWRAP>
		<FONT COLOR=\"$ctext\">題名</FONT></TH>
		<TD><INPUT TYPE=\"text\" NAME=\"head\" SIZE=\"45\" VALUE=\"$headbuf\"></TD></TR>
		";
	}
	
	($cook eq ".") || ($cookbuf = "CHECKED");
	
	"
<A NAME=\"form\">
<FORM NAME=\"H\" METHOD=\"$method\" ACTION=\"$script_name.$ext\">
<INPUT TYPE=\"hidden\" NAME=\"book\" VALUE=\"$book\">
<INPUT TYPE=\"hidden\" NAME=\"md5sum\" VALUE=\"$md5sum\">
$html_prehidden
<TABLE BORDER=\"0\" CELLPADDING=\"2\" CELLSPACING=\"0\">
<TR><TH WIDTH=\"50\" ALIGN=\"right\" NOWRAP><FONT COLOR=\"$ctext\">名前</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"name\" SIZE=\"20\" VALUE=\"$name\">
</TD></TR>
<TR><TH WIDTH=\"50\" ALIGN=\"right\" NOWRAP><FONT COLOR=\"$ctext\">メール</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"mail\" SIZE=\"30\" VALUE=\"$mail\"></TD></TR>
<TR><TH WIDTH=\"50\" ALIGN=\"right\" NOWRAP><FONT COLOR=\"$ctext\">ＵＲＬ</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"url\" SIZE=\"45\" VALUE=\"$url\"></TD></TR>
$html_head
<TR><TH WIDTH=\"50\">&nbsp;</TH>
<TD><FONT COLOR=\"$ctext\">
<TEXTAREA NAME=\"cont\" COLS=\"55\" ROWS=\"8\">$contbuf</TEXTAREA><BR>
<FONT SIZE=\"2\"><I>※ 名前と内容は必須です。文章は全角$max_words文字まで。タグは使えません。</FONT></FONT></TD></TR>
<TR><TH WIDTH=\"50\" ALIGN=\"right\" NOWRAP><FONT COLOR=\"$ctext\">&nbsp;</FONT></TH>
<TD valign=\"middle\"><IMG SRC=\"$capurl/$md5sum.png\"></TD></TR>
<TR><TH WIDTH=\"50\" ALIGN=\"right\" NOWRAP><FONT COLOR=\"$ctext\">&nbsp;</FONT></TH>
<TD valign=\"middle\"><INPUT TYPE=\"text\" NAME=\"capcode\" SIZE=\"10\" VALUE=\"\" style=\"ime-mode:disabled\;\" istyle=\"3\" format=\"*x\" MODE=\"alphabet\"><FONT SIZE=\"2\"> ※ >必須！上の画像から読める文字を入力してください。(半角英数字)</FONT></TD></TR>
<TR><TH WIDTH=\"50\">&nbsp;</TH>
<TD><FONT COLOR=\"$ctext\">
$html_pphrase<BR>
<INPUT TYPE=\"submit\" NAME=\"write\" VALUE=\"&nbsp;&nbsp;$html_submitlabel &nbsp;&nbsp;\">
$html_preview
<INPUT TYPE=\"reset\" VALUE=\"クリア\">
<FONT SIZE=\"2\" COLOR=\"$cnumb\">
<INPUT TYPE=\"checkbox\" NAME=\"cook\" VALUE=\"1\" $cookbuf>名前、メール、ＵＲＬ、削除キーをブラウザに記憶させる</FONT><BR>
<INPUT TYPE=\"hidden\" NAME=\"cook\" VALUE=\".\">
$html_search
</FONT></TD></TR>
</TABLE>
</FORM>
<HR NOSHADE SIZE=\"1\">
	";
	
}



########## 発言表示
sub html_articles{
	local($htmlbuf, %C, $arttp, $html_line, $host, $replys);
	
	### 発言の表示
	$arttp = &article_template;
	foreach(@datas){
		undef %C;
		($C{'ID'}, $C{'PID'}, $C{'DATE'}, $C{'NAME'}, $host, $C{'MAIL'}, $C{'URL'}, $C{'HEAD'}, $C{'CONT'}, $repline) = split("\t");
		
		# 件名か本文にスパムキーワードが含まれていた場合
		if (&check_spamword($C{'NAME'}.$C{'URL'}.$C{'MAIL'}.$C{'CONT'}.$C{'HEAD'}))
		{
			if($sw_showdel)
			{
				$htmlbuf .= "<FONT SIZE=\"2\" COLOR=\"$cnumb\"><B>No.$C{'ID'}</B> <i>(SPAM)</i></FONT><HR NOSHADE SIZE=\"1\">";
			}
			next;
		}
		
		# 削除されていた場合
		if($C{'PID'} eq "D"){
			($sw_showdel) && ($htmlbuf .= "<FONT SIZE=\"2\" COLOR=\"$cnumb\"><B>No.$C{'ID'}</B> (削除済)</FONT><HR NOSHADE SIZE=\"1\">");
			next;
		}
		
		# ホスト表示
		$C{'HOST'} = ($sw_host && $host) ? "&nbsp;&nbsp;<FONT SIZE=\"2\">(<I>$host</I>)</FONT>" : "";
		
		### コメントメッセージ
		if($sw_reply){
			$C{'REPLY'} .= "
			<DIV ALIGN=\"left\" style=\"margin-left:50px\;\">
			<FONT SIZE=\"2\">
			";
			
			# 今までの返事を表示
			@replys = split("<R>", $repline);
			foreach(@replys){
				($rtime, $rname, $rcont, $rno) = split("<>");
				
				# スパムワードが含まれていた場合
				if(&check_spamword($rname.$rcont))
				{
					if($sw_showdel)
					{
						$C{'REPLY'} .= "
						<FONT COLOR=\"$crtxt\">[Re.$rno]&nbsp;<i>(SPAM)</i></FONT><BR>
						";
					}
				}
				else
				{
					$C{'REPLY'} .= "
					<FONT COLOR=\"$crtxt\">[Re.$rno]&nbsp;<FONT COLOR=\"$crnam\"><B>$rname</B></FONT><I>($rtime)</I>＞&nbsp;$rcont&nbsp;</FONT><BR>
					";
				}
			}
			$C{'REPLY'} .= "</FONT></DIV>";
		}
		
		### コメント用フォーム（一般用）
		if($sw_reply == 1){
			$C{'REPLY'} .= "
			<P>
			<DIV ALIGN=\"center\">
			<FORM METHOD=\"$method\" ACTION=\"$script_name.$ext#$C{'ID'}\">
			<INPUT TYPE=\"hidden\" NAME=\"book\" VALUE=\"$book\">
			<INPUT TYPE=\"hidden\" NAME=\"page\" VALUE=\"$page\">
			<INPUT TYPE=\"hidden\" NAME=\"repid\" VALUE=\"$C{'ID'}\">
			<INPUT TYPE=\"hidden\" NAME=\"md5sum\" VALUE=\"$md5sum\">
			<FONT SIZE=\"2\">
			<FONT COLOR=\"$chead\"><B>返信：</B></FONT>
			名前<INPUT TYPE=\"text\" NAME=\"repname\" SIZE=\"8\" VALUE=\"$name\">&nbsp;
			ひとこと<INPUT TYPE=\"text\" NAME=\"repcont\" SIZE=\"35\" VALUE=\"\">&nbsp;
			キャプチャ文字<INPUT TYPE=\"text\" NAME=\"capcode\" SIZE=\"10\" VALUE=\"\" style=\"ime-mode:disabled\;\" istyle=\"3\" format=\"*x\" MODE=\"alphabet\">&nbsp;
			削除キー<INPUT TYPE=\"password\" NAME=\"ppr\" SIZE=\"5\" VALUE=\"$ppr\">&nbsp;
			<INPUT TYPE=\"submit\" NAME=\"reply\" VALUE=\"発言\">
			</FORM></FONT></DIV>
			";
		}
		
		### 発言タイトル
		($sw_head) || ($C{'HEAD'} = "");
		
		# テンプレート取得→置換
		$html_line = $arttp;
		$html_line =~ s/#(\w+)#/$C{$1}/g;
		$htmlbuf .= $html_line;
	}
	
	$htmlbuf;
}



########## 検索窓
sub html_search{
	local($type_or, $type_and);
	
	($type eq 'or') ? ($type_or = "CHECKED") : ($type_and = "CHECKED");
	
	unless($find){
		@datas = ();
		$html_nomatch = "<H3><FONT COLOR=\"$cnumb\">検索文字列を入力して下さい。</FONT></H3><HR NOSHADE SIZE=\"1\">";
	}
	
	"
<DIV ALIGN=\"center\">
<FORM METHOD=\"$method\" ACTION=\"$script_name.$ext\">
<INPUT TYPE=\"hidden\" NAME=\"book\" VALUE=\"$book\">
<INPUT TYPE=\"hidden\" NAME=\"search\" VALUE=\"1\">
記事検索：
<INPUT TYPE=\"text\" NAME=\"find\" SIZE=\"20\" VALUE=\"$find\">&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"type\" VALUE=\"and\" $type_and>AND&nbsp;
<INPUT TYPE=\"radio\" NAME=\"type\" VALUE=\"or\" $type_or>OR&nbsp;
<INPUT TYPE=\"submit\" VALUE=\"検索\">
</FORM>
</DIV>
<HR NOSHADE SIZE=\"1\">
	";
}



########## プレビュー
sub html_preview{
	local($artbuf, $host, %C);
	
	($C{'ID'}, $C{'PID'}, $C{'DATE'}, $C{'NAME'}, $host, $C{'MAIL'}, $C{'URL'}, $C{'HEAD'}, $C{'CONT'}) = split("\t", $newline);
	($sw_host) && ($C{'HOST'} = "&nbsp;&nbsp;<FONT SIZE=\"2\">(<I>$host</I>)</FONT>");
	
	$artbuf = &article_template;
	$artbuf  =~ s/#(\w+)#/$C{$1}/g;
	
	### プレビューの場合元の情報を載せる
	### タグを改行に逆変換
	$contbuf = $C{'CONT'};
	$contbuf =~ s/<BR>/\n/g;
	$contbuf =~ s/<P>/\n\n/g;
	$headbuf = $head;
	
	"
<FORM METHOD=\"post\" ACTION=\"$script_name.$ext\">
<INPUT TYPE=\"hidden\" NAME=\"book\" VALUE=\"$book\">
<INPUT TYPE=\"hidden\" NAME=\"name\" VALUE=\"$C{'NAME'}\">
<INPUT TYPE=\"hidden\" NAME=\"mail\" VALUE=\"$C{'MAIL'}\">
<INPUT TYPE=\"hidden\" NAME=\"url\" VALUE=\"$C{'URL'}\">
<INPUT TYPE=\"hidden\" NAME=\"head\" VALUE=\"$C{'HEAD'}\">
<INPUT TYPE=\"hidden\" NAME=\"cont\" VALUE=\"$contbuf\">
<INPUT TYPE=\"hidden\" NAME=\"ppr\" VALUE=\"$ppr\">
<INPUT TYPE=\"hidden\" NAME=\"cook\" VALUE=\"$cook\">
<INPUT TYPE=\"hidden\" NAME=\"chk\" VALUE=\"0\">
<DIV ALIGN=\"center\">
<TABLE WIDTH=\"90%\" BORDER=\"3\" CELLPADDING=\"0\" CELLSPACING=\"0\"><TR><TH>
<TABLE WIDTH=\"100%\" BORDER=\"0\" CELLPADDING=\"5\" CELLSPACING=\"0\">
<TR><TD><FONT SIZE=\"3\"><B>◆ プレビューモード</B></FONT></TD></TR>
<TR><TD>$artbuf</TD></TR>
<TR><TD>
<FONT SIZE=\"3\">これでよろしければボタンを押してください → 
<INPUT TYPE=\"submit\" VALUE=\"発言\"><BR>

</TD></TR>
</FONT>
</TD></TR></TABLE>
</TH></TR></TABLE>
</DIV>
</FORM>
<HR NOSHADE SIZE=\"1\">
	";
}



########## 削除フォーム
sub html_form_delete{
	local($htmlbuf);
	
	$htmlbuf .= "
	<A NAME=\"delform\">
	<DIV ALIGN=\"center\">
	<FONT SIZE=\"2\">
	<FORM METHOD=\"$method\" ACTION=\"$script_name.$ext\">
	<INPUT TYPE=\"hidden\" NAME=\"book\" VALUE=\"$book\">
	<INPUT TYPE=\"hidden\" NAME=\"page\" VALUE=\"$page\">
	<B>発言削除</B>：No.<INPUT TYPE=\"text\" NAME=\"delid\" style=\"ime-mode:disabled\;\" SIZE=\"4\">
	-Re.<INPUT TYPE=\"text\" NAME=\"delre\" style=\"ime-mode:disabled\;\" SIZE=\"3\">
	&nbsp;&nbsp;
	削除キー又はパスワード：<INPUT TYPE=\"password\" NAME=\"pwd\" SIZE=\"10\" VALUE=\"$pwd\">
	<INPUT TYPE=\"submit\" NAME=\"del\" VALUE=\"削除実行\">
	<INPUT TYPE=\"submit\" NAME=\"admin\" VALUE=\"管理モード\"><BR>
	";
	
	if($sw_reply == 2){
		$htmlbuf .= "
		<B>返信：</B>
		発言No.<INPUT TYPE=\"text\" NAME=\"repid\" SIZE=\"3\" VALUE=\"$name\">&nbsp;
		名前<INPUT TYPE=\"text\" NAME=\"repname\" SIZE=\"8\" VALUE=\"$name\">&nbsp;
		ひとこと<INPUT TYPE=\"text\" NAME=\"repcont\" SIZE=\"35\" VALUE=\"\">&nbsp;
		<INPUT TYPE=\"submit\" NAME=\"reply\" VALUE=\"発言\"><BR>
		";
	}

	
	$htmlbuf .= "
	</FORM></FONT></DIV>
	<HR NOSHADE SIZE=\"1\">
	";
	
	$htmlbuf;
}



########## 管理フォーム
sub html_form_admin{
	local($bgc, $fnc);
	local($fm1, $fm0, $pv1, $pv0, $pp1, $pp0, $sc1, $sc0);
	local($hd1, $hd0, $hs1, $hs0, $rp1, $rp0, $rp2, $sd1, $sd0);
	
	$bgc = "#6666FF";
	$fnc = "#FFFFFF";
	
	### スイッチ処理
	($sw_form)	? ($fm1 = "CHECKED") : ($fm0 = "CHECKED");
	($sw_preview) ? ($pv1 = "CHECKED") : ($pv0 = "CHECKED");
	($sw_ppr)	 ? ($pp1 = "CHECKED") : ($pp0 = "CHECKED");
	($sw_search)  ? ($sc1 = "CHECKED") : ($sc0 = "CHECKED");
	($sw_head)	? ($hd1 = "CHECKED") : ($hd0 = "CHECKED");
	($sw_host)	? ($hs1 = "CHECKED") : ($hs0 = "CHECKED");
	($sw_reply)   ? ($rp1 = "CHECKED") : ($rp0 = "CHECKED");
	($sw_showdel) ? ($sd1 = "CHECKED") : ($sd0 = "CHECKED");
	($sw_anobar)  ? ($an1 = "CHECKED") : ($an0 = "CHECKED");
	if($sw_reply == 2){
		$rp1 = "";
		$rp2 = "CHECKED";
	}
	if($sw_ppr == 2){
		$pp1 = "";
		$pp2 = "CHECKED";
	}
	if($sw_preview == 2){
		$pv1 = "";
		$pv2 = "CHECKED";
	}
	
	
	### タグ殺し
	$ktitle = &killtag($title);
	$kheadline = &killtag($headline);
	$kcomment = &killtag($comment);
	
	"
<FORM METHOD=\"$method\" ACTIONT=\"$script_name.$ext\">
<INPUT TYPE=\"hidden\" NAME=\"book\" VALUE=\"$book\">
<INPUT TYPE=\"hidden\" NAME=\"pwd\" VALUE=\"$pwd\">
<INPUT TYPE=\"hidden\" NAME=\"admin\" VALUE=\"true\">
<DIV ALIGN=\"center\">
<TABLE BORDER=\"0\" WIDTH=\"100%\" BGCOLOR=\"#CCCCFF\">
<TR><TH BGCOLOR=\"#000099\"><FONT SIZE=\"5\" COLOR=\"#FFFFFF\">
◆ T-Note-cap $verno 管理用フォーム ◆</FONT></TH></TR>
<TR><TD><FONT SIZE=\"3\" COLOR=\"#000000\">
<FONT SIZE=\"2\">※ 当管理ページは IE4以上またはNN3以上をお使いください。</FONT>
<DIV ALIGN=\"center\">
<TABLE BGCOLOR=\"#FFFFFF\" WIDTH=\"98%\" BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\">
<TR><TH BGCOLOR=\"$bgc\" NOWRAP><FONT COLOR=\"$fnc\">タイトル</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"atitle\" SIZE=\"50\" VALUE=\"$ktitle\"></TD></TR>
<TR><TH BGCOLOR=\"$bgc\" NOWRAP><FONT COLOR=\"$fnc\">見出し</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"ahead\" SIZE=\"50\" VALUE=\"$kheadline\"></TD></TR>
<TR><TH BGCOLOR=\"$bgc\" NOWRAP><FONT COLOR=\"$fnc\">説明文</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"acom\" SIZE=\"50\" VALUE=\"$kcomment\"></TD></TR>
<TR><TH BGCOLOR=\"$bgc\" NOWRAP><FONT COLOR=\"$fnc\">戻り先</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"aback\" SIZE=\"30\" VALUE=\"$backurl\"></TD></TR>
<TR><TH BGCOLOR=\"$bgc\" NOWRAP><FONT COLOR=\"$fnc\">表\示単位</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"asdef\" SIZE=\"5\" VALUE=\"$show_scale\">発言ずつ表\示</TD></TR>
<TR><TH BGCOLOR=\"$bgc\" NOWRAP><FONT COLOR=\"$fnc\">配色</FONT></TH>
<TD>
全体：文字<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$ctext\">&nbsp;
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
背景<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$cbody\">&nbsp;<BR>
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
リンク：通常<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$clink\">&nbsp;
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
訪問済<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$cvlnk\">&nbsp;
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
クリック<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$calnk\">&nbsp;<BR>
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
発言：名前<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$cname\">&nbsp;
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
番号<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$cnumb\">&nbsp;
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
発言タイトル<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$chead\">&nbsp;<BR>
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
返信：名前<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$crnam\">&nbsp;
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
発言<INPUT TYPE=\"text\" NAME=\"acol\" SIZE=\"10\" VALUE=\"$crtxt\">&nbsp;<BR>
<INPUT TYPE=\"hidden\" NAME=\"acol\" VALUE=\",\">
<INPUT TYPE=\"checkbox\" NAME=\"colreset\" VALUE=\"1\">標準の配色に戻す
</TD>
<TR><TH BGCOLOR=\"$bgc\" NOWRAP><FONT COLOR=\"$fnc\">背景画像</FONT></TH>
<TD><INPUT TYPE=\"text\" NAME=\"abgimg\" SIZE=\"30\" VALUE=\"$bgimg\">
</TD>
<TR><TH BGCOLOR=\"$bgc\" NOWRAP><FONT COLOR=\"$fnc\">ログ保存件数</FONT></TH>
<TD>最新<INPUT TYPE=\"text\" NAME=\"alg\" SIZE=\"4\" VALUE=\"$sw_log\">件
<FONT SIZE=\"2\">※ 「０件」にすると「全ログを保存」になります。</FONT>
</TD></TR>
</TABLE>

<TABLE BGCOLOR=\"#FFFFFF\" WIDTH=\"98%\" BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\">
<TR><TH BGCOLOR=\"$bgc\" NOWRAP ROWSPAN=\"9\"><FONT COLOR=\"$fnc\">スイッチ</FONT></TH>
<TH>発言フォームの位置</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"afm\" VALUE=\"0\" $fm0>記事の下&nbsp;
<INPUT TYPE=\"radio\" NAME=\"afm\" VALUE=\"1\" $fm1>記事の上</TD></TR>
<TR><TH>プレビューボタン</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"apv\" VALUE=\"0\" $pv0>なし&nbsp;
<INPUT TYPE=\"radio\" NAME=\"apv\" VALUE=\"1\" $pv1>あり&nbsp;
<INPUT TYPE=\"radio\" NAME=\"apv\" VALUE=\"2\" $pv2>常にプレビュー&nbsp;</TD></TR>
<TR><TH>削除キー</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"app\" VALUE=\"0\" $pp0>なし&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"app\" VALUE=\"1\" $pp1>あり
<INPUT TYPE=\"radio\" NAME=\"app\" VALUE=\"2\" $pp2>必須
</TD></TR>
<TR><TH>検索モード</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"asc\" VALUE=\"0\" $sc0>なし&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"asc\" VALUE=\"1\" $sc1>あり</TD></TR>
<TR><TH>発言タイトル</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"ahd\" VALUE=\"0\" $hd0>なし&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"ahd\" VALUE=\"1\" $hd1>あり</TD></TR>
<TR><TH>発言者のホスト</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"ahs\" VALUE=\"0\" $hs0>非表\示&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"ahs\" VALUE=\"1\" $hs1>表\示</TD></TR>
<TR><TH>ひとこと返信</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"arp\" VALUE=\"0\" $rp0>不可&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"arp\" VALUE=\"1\" $rp1>可&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"arp\" VALUE=\"2\" $rp2>管理者のみ可</TD></TR>
<TR><TH>削除された発言</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"asd\" VALUE=\"0\" $sd0>何も表\示しない&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"asd\" VALUE=\"1\" $sd1>「削除済」の文字を表\示</TD></TR>
<TR><TH>リンクの下線</TH>
<TD><INPUT TYPE=\"radio\" NAME=\"aan\" VALUE=\"0\" $an0>あり&nbsp;&nbsp;
<INPUT TYPE=\"radio\" NAME=\"aan\" VALUE=\"1\" $an1>なし</TD></TR>
</TABLE>
</DIV>
<P>

<INPUT TYPE=\"submit\" NAME=\"fix\" VALUE=\"作業実行\">
[<A HREF=\"$script_name.$ext?book=$book\"><FONT COLOR=\"#000099\">通常モードに戻る</FONT></A>]
</FONT>
</FONT></TD></TR></TABLE>
</DIV>
</FORM>
<HR NOSHADE SIZE=\"1\">
	";
}



#################### クッキーの処理

########## メイン
sub deal_cookie{
	# 名前が空欄ならクッキーの取得
	($name) || &get_cookie;
	# 発言の際指定されたらクッキーの保存
	($cook && $name && $cont && !$F{'chk'}) && &set_cookie;
}



########## クッキーを取り出す
sub get_cookie{
	local($cookbuf);
	
	# 現在のBOOK向けクッキーがなければ終了
	(($cookbuf) = $ENV{'HTTP_COOKIE'} =~ m|$book=([^;]+)|) || return;
	
	$cookbuf =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
	($name, $mail, $url, $ppr) = split("\t", $cookbuf);
	
	$cook = 1;
}



########## クッキーの発行
sub set_cookie{
	local($expires, $path, $value);
	
	$expires = &get_time_GMT($^T + 60 * 60 * 24 * $cookie_lifetime);
	if($enable_cookiepath){
		($path) = $ENV{'SCRIPT_NAME'} =~ m|^(.+/)[^/]+$|;
		$path = "path=" . $path;
	}
	
	$value = "$name\t$mail\t$url\t$ppr";
	$value =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
	$cookieline = "Set-Cookie: $book=$value; expires=$expires; $path\n";
}



########## 日本語のデコード
sub decode{
	local($w, $frag) = @_;
	
	$w =~ tr/+/ /;
	$w =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	
	unless($frag){
		$w =~ s/</&LT;/g;
		$w =~ s/>/&GT;/g;
		$w =~ s/"/&#34;/g;
		$w =~ s/'/&#39;/g;
	}
	
	$w =~ s/\t//g;
	$w =~ s/\cM//g;
	$w =~ s/\n{2,}/<P>/g;
	$w =~ s/\n/<BR>/g;
	
#	&jcode'convert(*w, $code);
	$w;
}



##### タグを殺す
sub killtag{
	local($w) = @_;
	
	$w =~ s/</&LT;/g;
	$w =~ s/>/&GT;/g;
	$w =~ s/"/&#34;/g;
	$w =~ s/'/&#39;/g;
	
	$w;
}



##### スパムキーワードをチェック
$spam_pattern = "";
sub check_spamword
{
	(@spamwords) || return;
	
	local($chkstr) = @_;
	
	# キーワードの初期化処理
	if(!$spam_pattern)
	{
		foreach(@spamwords)
		{
			s/(\W)/\\$1/g;
			$spam_pattern .= $_ . "|";
		}
		chop($spam_pattern);
	}
	
	# スパムワードがあったら1を、なかったら0を返す
	if($chkstr =~ /$spam_pattern/)
	{
		return 1;
	}
	return 0;
}



##### 現在の時刻を得る
sub get_time{
	local($stime) = @_;
	$stime += $time_fix * 60 * 60;
	local($sec, $min, $hour, $mday, $mon, $year) = localtime($stime);
	$mon++;
	$year += 1900;
	return sprintf("%04d/%02d/%02d %02d:%02d", $year, $mon, $mday, $hour, $min);
}



###### ファイルを開いて、中身を配列に代入する
sub openfile{
	local ($filename, *buf) = @_;
	open(FILE, "$filename") || &error(1, $filename);
	@buf = <FILE>;
	close(FILE);
}



###### ファイルを更新する
sub updatefile{
	local ($filename, *buf, $frag) = @_;
	
	# フラグあり→追加、なし→更新
	if($frag){
		open(FILE, ">>$filename") || &error(1, $filename);
	}
	else{
		open(FILE, ">$filename") || &error(1, $filename);
	}
	print FILE @buf;
	close(FILE);
}



##### ＧＭＴを得る（クッキー用）
sub get_time_GMT{
	local($tsec) = @_;
	local($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime($tsec);
	$wday = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat')[$wday];
	$mon = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec')[$mon];
	$year += 1900;
	return sprintf("$wday, %02d-$mon-$year %02d:%02d:%02d GMT", $mday, $hour, $min, $sec);
}



##### ロック
sub lock{
	$try = 0;
	while(!mkdir($lockfile, 0700))
	{
		(++$try > 3) && &error(0);
		sleep(1);
	}
}



##### ロック解除
sub unlock{
	rmdir($lockfile);
}



##### エラーメッセージ
sub error{
	local ($id, $msg) = @_;
	local (@sts) = lstat($lockfile);
	local ($tn) = time();
	
	$fmid[0] = 0; $msg[0] = 'ロック中です';
	$fmid[1] = 1; $msg[1] = 'ファイルが開けません';
	$fmid[2] = 1; $msg[2] = 'ファイルに書き込めません';
	$fmid[3] = 0; $msg[3] = 'book が指定されていません';
	$fmid[4] = 0; $msg[4] = 'book が不正です';
	$fmid[5] = 0; $msg[5] = 'メールアドレスが不正です';
	$fmid[6] = 0; $msg[6] = 'URLが不正です';
	$fmid[7] = 0; $msg[7] = '親発言番号が不正です';
	$fmid[8] = 0; $msg[8] = 'パスワードが間違っています';
	$fmid[9] = 0; $msg[9] = '削除する番号が指定されていないか不正です';
	$fmid[10] = 0; $msg[10] = "文章が長すぎます。全角で$max_words文字以下にして下さい";
	$fmid[11] = 0; $msg[11] = "変数が不正です";
	$fmid[12] = 0; $msg[12] = "返信は名前、コメント両方とも必須です";
	$fmid[13] = 0; $msg[13] = "返信には管理パスワードが必要です";
	$fmid[14] = 0; $msg[14] = "削除キーが入力されていません";
	$fmid[15] = 0; $msg[15] = 'メッセージがスパム判定に引っかかりました。投稿できません';
	$fmid[16] = 0; $msg[16] = 'キャプチャ文字が正しくありません';
	$fmid[17] = 0; $msg[17] = 'ブラックリストに入っています';
	
	
	$fmsg[0] = "Backを押して戻ってください。";
	$fmsg[1] = "管理者に連絡してください。";
	
	$fid = $fmid[$id];
	($msg) && ($detail = "<I>（$msg）</I>");
	
	print "Content-type: text/html\n\n";
	print "
<HTML>
<HEAD>
<META http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">
<TITLE>T-Note-cap 4 - Error!!</TITLE>
</HEAD>
<BODY BGCOLOR=\"#FFFFFF\">
<H3>エラー発生</H3>
<B>$msg[$id]</B> $detail<P>
$fmsg[$fid]
<HR>
<FONT SIZE=\"2\">
<B>管理者：<A HREF=\"mailto:$admin_email\">$admin_email</A></B><BR>
※ ご一報の際には、サイトのＵＲＬ、症状等をお書き添え下さいますようお願いします。
</FONT>
</BODY></HTML>
	";
	
	($id) && &unlock; # ID が 0 以外の場合はロック解除
	($tn - $sts[9] > 15) && &unlock; # 約15秒以上ロックが続いてたら自動解除
	exit;
}
